#include "engine.h"
#include <QtCore>

void Engine::showFriends(QString key) {
    qDebug() << "Friends of " << key << endl;
    FriendList& eq = m_friendMap[key];
    foreach (QString k, eq) 
        if (key != k) 
            qDebug() << QString(" [ %1=%2 ] ").arg(key).arg(k);
}

/** Returns the key of the object that was being worked on */
QString Engine::processLine(QString l) {
    if (l.startsWith("takeback")) {
        int wschar = l.lastIndexOf(' ');
        int removeIndex = l.mid(wschar).toInt();
        return takeback(removeIndex);
    }

    int i = l.indexOf('=');
    if (i>0) {
        QString key = l.left(i);
        QString value = l.mid(i+1);
        m_Messages.append(l);     /* By adding to a vector, we maintain integer id on
      each message */
        m_friendMap.set(value, key);
        m_friendMap.set(key, value);
        return key;
    }
    else {                        /* No "=" in input line - 
                                    just print out the equalities of that symbol */
        showFriends(l);
        return l;
    }
    return QString("Unrecognized Line: %1").arg(l);
}



QString Engine::takeback(int index) {
    if (m_Messages.count() < index) {
        qDebug() << "invalid index" << endl;
        return "";
    } else {
        QString line = m_Messages[index];
        qDebug() << "Taking Back: " << line << endl;
        int i = line.indexOf('=');
        QString key = line.left(i);
        QString value = line.mid(i+1);
        m_friendMap.unset(key, value);
        return key;
    }
}

void Engine::history() const {
    //    iterator itr<QString> =
}

int main(int argc, char** argv) {
    QTextStream cout(stdout);
    QTextStream cin(stdin);
    Engine engine;
    QString currentline;
    QString key;
    do {
        cout << " > " << flush;
        currentline = cin.readLine();
        key = engine.processLine(currentline);
    } while (currentline != QString()) ;
    return 0;
}

